<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="A collection of numeric types and traits for Rust."><meta name="keywords" content="rust, rustlang, rust-lang, num"><title>num - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="../crates.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc mod crate"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../num/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../num/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Crate num</a></h2><div class="sidebar-elems"><div class="block"><ul><li class="version">Version 0.4.0</li><li><a id="all-types" href="all.html">All Items</a></li></ul></div><section><div class="block"><ul><li><a href="#modules">Modules</a></li><li><a href="#structs">Structs</a></li><li><a href="#traits">Traits</a></li><li><a href="#functions">Functions</a></li><li><a href="#types">Type Definitions</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../num/index.html"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Crate <a class="mod" href="#">num</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/num/lib.rs.html#11-108">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>A collection of numeric types and traits for Rust.</p>
<p>This includes new types for big integers, rationals, and complex numbers,
new traits for generic programming on numeric properties like <code>Integer</code>,
and generic range iterators.</p>
<h3 id="example"><a href="#example">Example</a></h3>
<p>This example uses the BigRational type and <a href="https://en.wikipedia.org/wiki/Methods_of_computing_square_roots#Babylonian_method">Newton’s method</a> to
approximate a square root to arbitrary precision:</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code>
<span class="kw">use</span> <span class="ident">num::FromPrimitive</span>;
<span class="kw">use</span> <span class="ident">num::bigint::BigInt</span>;
<span class="kw">use</span> <span class="ident">num::rational</span>::{<span class="ident">Ratio</span>, <span class="ident">BigRational</span>};

<span class="kw">fn</span> <span class="ident">approx_sqrt</span>(<span class="ident">number</span>: <span class="ident">u64</span>, <span class="ident">iterations</span>: <span class="ident">usize</span>) -&gt; <span class="ident">BigRational</span> {
    <span class="kw">let</span> <span class="ident">start</span>: <span class="ident">Ratio</span><span class="op">&lt;</span><span class="ident">BigInt</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">Ratio::from_integer</span>(<span class="ident">FromPrimitive::from_u64</span>(<span class="ident">number</span>).<span class="ident">unwrap</span>());
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">approx</span> <span class="op">=</span> <span class="ident">start</span>.<span class="ident">clone</span>();

    <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">0</span>..<span class="ident">iterations</span> {
        <span class="ident">approx</span> <span class="op">=</span> (<span class="kw-2">&amp;</span><span class="ident">approx</span> <span class="op">+</span> (<span class="kw-2">&amp;</span><span class="ident">start</span> <span class="op">/</span> <span class="kw-2">&amp;</span><span class="ident">approx</span>)) <span class="op">/</span>
            <span class="ident">Ratio::from_integer</span>(<span class="ident">FromPrimitive::from_u64</span>(<span class="number">2</span>).<span class="ident">unwrap</span>());
    }

    <span class="ident">approx</span>
}

<span class="kw">fn</span> <span class="ident">main</span>() {
    <span class="macro">println!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">approx_sqrt</span>(<span class="number">10</span>, <span class="number">4</span>)); <span class="comment">// prints 4057691201/1283082416</span>
}
</code></pre></div>
<h3 id="compatibility"><a href="#compatibility">Compatibility</a></h3>
<p>The <code>num</code> crate is tested for rustc 1.31 and greater.</p>
</div></details><h2 id="modules" class="small-section-header"><a href="#modules">Modules</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="mod" href="cast/index.html" title="num::cast mod">cast</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="mod" href="complex/index.html" title="num::complex mod">complex</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="mod" href="integer/index.html" title="num::integer mod">integer</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="mod" href="iter/index.html" title="num::iter mod">iter</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="mod" href="pow/index.html" title="num::pow mod">pow</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="mod" href="rational/index.html" title="num::rational mod">rational</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="mod" href="traits/index.html" title="num::traits mod">traits</a></div><div class="item-right docblock-short"></div></div></div><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Complex.html" title="num::Complex struct">Complex</a></div><div class="item-right docblock-short"><p>A complex number in Cartesian form.</p>
</div></div></div><h2 id="traits" class="small-section-header"><a href="#traits">Traits</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Bounded.html" title="num::Bounded trait">Bounded</a></div><div class="item-right docblock-short"><p>Numbers which have upper and lower bounds</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.CheckedAdd.html" title="num::CheckedAdd trait">CheckedAdd</a></div><div class="item-right docblock-short"><p>Performs addition that returns <code>None</code> instead of wrapping around on
overflow.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.CheckedDiv.html" title="num::CheckedDiv trait">CheckedDiv</a></div><div class="item-right docblock-short"><p>Performs division that returns <code>None</code> instead of panicking on division by zero and instead of
wrapping around on underflow and overflow.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.CheckedMul.html" title="num::CheckedMul trait">CheckedMul</a></div><div class="item-right docblock-short"><p>Performs multiplication that returns <code>None</code> instead of wrapping around on underflow or
overflow.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.CheckedSub.html" title="num::CheckedSub trait">CheckedSub</a></div><div class="item-right docblock-short"><p>Performs subtraction that returns <code>None</code> instead of wrapping around on underflow.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.FromPrimitive.html" title="num::FromPrimitive trait">FromPrimitive</a></div><div class="item-right docblock-short"><p>A generic trait for converting a number to a value.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Integer.html" title="num::Integer trait">Integer</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Num.html" title="num::Num trait">Num</a></div><div class="item-right docblock-short"><p>The base trait for numeric types, covering <code>0</code> and <code>1</code> values,
comparisons, basic numeric operations, and string conversion.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.NumCast.html" title="num::NumCast trait">NumCast</a></div><div class="item-right docblock-short"><p>An interface for casting between machine scalars.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.One.html" title="num::One trait">One</a></div><div class="item-right docblock-short"><p>Defines a multiplicative identity element for <code>Self</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.PrimInt.html" title="num::PrimInt trait">PrimInt</a></div><div class="item-right docblock-short"><p>Generic trait for primitive integers.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Saturating.html" title="num::Saturating trait">Saturating</a></div><div class="item-right docblock-short"><p>Saturating math operations. Deprecated, use <code>SaturatingAdd</code>, <code>SaturatingSub</code> and
<code>SaturatingMul</code> instead.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Signed.html" title="num::Signed trait">Signed</a></div><div class="item-right docblock-short"><p>Useful functions for signed numbers (i.e. numbers that can be negative).</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.ToPrimitive.html" title="num::ToPrimitive trait">ToPrimitive</a></div><div class="item-right docblock-short"><p>A generic trait for converting a value to a number.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Unsigned.html" title="num::Unsigned trait">Unsigned</a></div><div class="item-right docblock-short"><p>A trait for values which cannot be negative</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Zero.html" title="num::Zero trait">Zero</a></div><div class="item-right docblock-short"><p>Defines an additive identity element for <code>Self</code>.</p>
</div></div></div><h2 id="functions" class="small-section-header"><a href="#functions">Functions</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.abs.html" title="num::abs fn">abs</a></div><div class="item-right docblock-short"><p>Computes the absolute value.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.abs_sub.html" title="num::abs_sub fn">abs_sub</a></div><div class="item-right docblock-short"><p>The positive difference of two numbers.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.cast.html" title="num::cast fn">cast</a></div><div class="item-right docblock-short"><p>Cast from one machine scalar to another.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.checked_pow.html" title="num::checked_pow fn">checked_pow</a></div><div class="item-right docblock-short"><p>Raises a value to the power of exp, returning <code>None</code> if an overflow occurred.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.clamp.html" title="num::clamp fn">clamp</a></div><div class="item-right docblock-short"><p>A value bounded by a minimum and a maximum</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.one.html" title="num::one fn">one</a></div><div class="item-right docblock-short"><p>Returns the multiplicative identity, <code>1</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.pow.html" title="num::pow fn">pow</a></div><div class="item-right docblock-short"><p>Raises a value to the power of exp, using exponentiation by squaring.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.range.html" title="num::range fn">range</a></div><div class="item-right docblock-short"><p>Returns an iterator over the given range [start, stop) (that is, starting
at start (inclusive), and ending at stop (exclusive)).</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.range_inclusive.html" title="num::range_inclusive fn">range_inclusive</a></div><div class="item-right docblock-short"><p>Return an iterator over the range [start, stop]</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.range_step.html" title="num::range_step fn">range_step</a></div><div class="item-right docblock-short"><p>Return an iterator over the range [start, stop) by <code>step</code>. It handles overflow by stopping.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.range_step_inclusive.html" title="num::range_step_inclusive fn">range_step_inclusive</a></div><div class="item-right docblock-short"><p>Return an iterator over the range [start, stop] by <code>step</code>. It handles overflow by stopping.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.signum.html" title="num::signum fn">signum</a></div><div class="item-right docblock-short"><p>Returns the sign of the number.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.zero.html" title="num::zero fn">zero</a></div><div class="item-right docblock-short"><p>Returns the additive identity, <code>0</code>.</p>
</div></div></div><h2 id="types" class="small-section-header"><a href="#types">Type Definitions</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="type" href="type.Rational.html" title="num::Rational type">Rational</a><span class="stab deprecated" title="">Deprecated</span></div><div class="item-right docblock-short"><p>Alias for a <code>Ratio</code> of machine-sized integers.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="type" href="type.Rational32.html" title="num::Rational32 type">Rational32</a></div><div class="item-right docblock-short"><p>Alias for a <code>Ratio</code> of 32-bit-sized integers.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="type" href="type.Rational64.html" title="num::Rational64 type">Rational64</a></div><div class="item-right docblock-short"><p>Alias for a <code>Ratio</code> of 64-bit-sized integers.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="num" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>